/*
 * wath_cgi.c - wath  CGI ⥸塼
 *    Sun, Jun 16 1996 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#if defined(__FreeBSD__)
#include <sys/socket.h>
#endif
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>
#include <pwd.h>
#include "status_code.h"
#include "common.h"
#include "request.h"
#include "server.h"

/*
 * ޥ
 */
#define	STDIN_FILENO	0	/* ɸϥե뵭һ		*/
#define	STDOUT_FILENO	1	/* ɸϥե뵭һ		*/
#define	STDERR_FILENO	2	/* ɸ२顼ϥե뵭һ		*/
#define	MAX_ENVIRONMENT	22	/* CGI ޥɤϤĶѿξ	*/
#define	READ		0	/* ɤ߹ߥե뵭һ		*/
#define	WRITE		1	/* 񤭹ߥե뵭һ		*/
#define	TIMEOUT		300	/* ॢ()			*/
#define	CGI_SUFFIX	".cgi"	/* CGI ޥɤμѳĥ		*/

#if	!defined(__FreeBSD__)
#define	SIG_T		void*
#else
#define	SIG_T		sig_t
#endif

/*
 * ɽؿ
 */
static void	SigchldHandler();
static void	TimeoutCGI();
static void	ExecCommandOfCGI();
static void 	SetEnvironments();
static void	MakeNewEnvironment();
static void	FreeMakedEnvironment();

/*
 * ɽѿ
 */
static int	pfd[2];			/* ƻҥץ̿ѥѥ	*/
static int	envno;			/* ꤷĶѿο		*/
static char	*env[MAX_ENVIRONMENT];	/* Ķѿ			*/

/*
 * ؿ̾:	TreatCGI
 * ǽ:	CGI ǽ
 * :	ꥯȹ¤ΤؤΥݥ
 * :	ʤ
 */
void TreatCGI(req)
	Request	*req;
{
  register char	*p, *s;
  char		work_dir[PATH_LEN], cgi_path[PATH_LEN];
  int		i;
  struct stat	status;

  /* CGI ޥɼ¹ԻδĶѿ	*/
  SetEnvironments(req);

  /* CGI ޥɤΥѥºݤΥѥѹ	*/
  for (i=0; req->url[i] == serv.cgi.virtual[i]; i++) {
    ;
  }

  /* CGI ¹ԥǥ쥯ȥ	*/
  (void)sprintf(work_dir, "%s", serv.cgi.real);
  s = req->url+i;
  while ((p = (char *)strchr(s, '/')) != NULL) {
    *p = EOL;
    if (*s == EOL) {
      (void)strcat(work_dir, "/");
    }
    else {
      (void)strcat(work_dir, s);
    }
    s = p + 1;
  }

  /* CGI ޥ̾	*/
  (void)sprintf(cgi_path, "%s", s);

  /* CGI ¹ԥǥ쥯ȥ˰ư	*/
  if (chdir(work_dir) < 0) {
    ErrorTrap(INTERNAL_SERVER_ERROR);
    FreeMakedEnvironment();	/* ΰγ	*/
    return;
  }

  /* ꤵ줿 CGI ޥɡեΥơμ	*/
  if (stat(cgi_path, &status) < 0) {
    ErrorTrap(NOT_FOUND);
    FreeMakedEnvironment();	/* ΰγ	*/
    return;
  }

  /* ᥽åɤ HEAD ξν	*/
  if (IsEqual(req->method, "HEAD")) {
    SendHttpHeader(OK, &status, DEFAULT_TYPE);
    FreeMakedEnvironment();	/* ΰγ	*/
    return;
  }

  /* ꤵ줿 CGI ޥɡե뤬¹ԤǤ뤫Υå	*/
  if (!(S_ISREG(status.st_mode) && (status.st_mode & S_IXOTH))) {
    ErrorTrap(CGI_PERMISSION_DENIED);
    FreeMakedEnvironment();	/* ΰγ	*/
    return;
  }

  ExecCommandOfCGI(req->method, cgi_path);	/* CGI ޥɼ¹	*/
  FreeMakedEnvironment();	/* ΰγ	*/
}

/*
 * ؿ̾:	ExecCommandOfCGI
 * ǽ:	CGI ޥɤºݤ˼¹
 * :	᥽åɡCGI ޥɤΥѥ
 * :	ʤ
 */
static void ExecCommandOfCGI(method, cgi_path)
	char	*method, *cgi_path;
{
  pid_t	pid;
  int	nbyte;
  char	buf[BUF_SIZE];
#ifdef	HPUX
  int		width;
  fd_set	mask, mread;
#endif	/* HPUX */

  /* ʥ롦ϥɥ	*/
  signal(SIGCHLD, (SIG_T)SigchldHandler);
  signal(SIGPIPE, (SIG_T)TimeoutCGI);

  /* ѥפκ	*/  
  if (pipe(pfd) < 0) {
    ErrorTrap(INTERNAL_SERVER_ERROR);
    return;
  }

  /* ॢȤ	*/
  signal(SIGALRM, (SIG_T)TimeoutCGI);
  (void)alarm(TIMEOUT);

  /* ҥץ	*/
#ifdef	HAVE_VFORK
  if ((pid = vfork()) < (pid_t)0) {
#else
  if ((pid = fork()) < (pid_t)0) {
#endif	/* HAVE_VFORK */
    ErrorTrap(INTERNAL_SERVER_ERROR);
    return;
  }
  else if (pid == (pid_t)0) {		/* ҥץ	*/
    /* ɸϤ pfd[WRITE] ³	*/
    if (dup2(pfd[WRITE], STDOUT_FILENO) < 0) {	/* ɸϤ³	*/
      ErrorTrap(INTERNAL_SERVER_ERROR);
      return;
    }
    if (IsEqual(method, "POST")) {	/* POST ᥽åɤξν	*/
      if (dup2(sd, STDIN_FILENO) < 0) {	/* åȤɸϤ³	*/
	ErrorTrap(INTERNAL_SERVER_ERROR);
	return;
      }
    }
    else {				/* GET ᥽åɤξν	*/
      (void)close(pfd[READ]);		/* ɤ߹¦Ĥ	*/
    }
    execle(cgi_path, cgi_path, (char *)NULL, env);	/* CGI ¹	*/
    ErrorTrap(INTERNAL_SERVER_ERROR);
    return;
  }
  else {				/* ƥץ	*/
    (void)close(pfd[WRITE]);		/* 񤭹¦Ĥ		*/

#ifdef	HPUX				/* HP-UX ˤȯХ	*/
    if (errno == ECONNREFUSED) {	/* Τȥåפ	*/
      ErrorTrap(INTERNAL_SERVER_ERROR);	/* libresolv.a 󥯤	*/
      return;				/* ϲ褵줿ʤ	*/
    }
#endif	/* HPUX */

    /* إå	*/
    (void)sprintf(buf, "%s %d %s\r\n", PROTOCOL, status_code[OK].code,
		  status_code[OK].type);
    (void)write(sd, buf, strlen(buf));

    /* ̤򥯥饤Ȥ	*/
#ifdef	HPUX					/* HP-UX ̽	*/
    FD_ZERO(&mask);
    FD_SET(pfd[READ], &mask);
    width = pfd[READ] + 1;
    nbyte = 1;
    while (nbyte > 0) {
      mread = mask;
      select(width, &mread, NULL, NULL, NULL);
      nbyte = read(pfd[READ], buf, BUF_SIZE);
      write(sd, buf, (size_t)nbyte);
    }
#else						/* ¾ OS Ϥä	*/
    while ((nbyte = read(pfd[READ], buf, BUF_SIZE)) > 0) {
      write(sd, buf, (size_t)nbyte);
    }
#endif	/* HPUX */

    if (errno == EINTR) {	/* ҥץνλԤ	*/
      (void)WaitProcess();
    }
  }
}

/*
 * ؿ̾:	SigchldHandler
 * ǽ:	ҥץνλԤ(ӡץʤ)
 * :	ʤ
 */
static void SigchldHandler(void)
{
  wait(NULL);
}

/*
 * ؿ̾:	TimeoutCGI
 * ǽ:	ॢȻν
 * :	ʤ
 */
static void TimeoutCGI(void)
{
  (void)close(pfd[WRITE]);
  (void)close(pfd[READ]);
  (void)shutdown(sd, 2);
  (void)close(sd);
}

/*
 * ؿ̾:	SetEnvironments
 * ǽ:	ФδĶѿ
 * :	ꥯȹ¤ΤؤΥݥ
 * :	ʤ
 *
 * []
 *
 *  SERVER_NAME	CGI:	ץȤ¹ԤƤۥ̾
 *  SERVER_SOFTWARE:	CGI ץȤưФμ
 *  GATEWAY_INTERFACE:	Ф¹ԤƤ CGI ΥС
 *  SERVER_PROTOCOL:	Ф¹ԤƤ HTTP ץȥ롦С
 *  SERVER_PORT:	ФѤƤ TCP ݡֹ
 *  REQUEST_METHOD:	ե(GET or POST)
 *  HTTP_ACCEPT:	֥饦ľɽǤ Content-type ΰ
 *  HTTP_USER_AGENT:	֥饦̾
 *  HTTP_REFER:		Υե Web ɥȤ URL
 *  PATH_INFO:		CGI ޥɤθƤӽФˤ ץ  URL 
 *			ղäƤѥ
 *  PATH_TRANSLATED:	PATH_INFO äƤ򥷥ƥͭΥѥ̾
 *			Ѵ
 *  SCRIPT_NAME:	 CGI ΥץȤ̾
 *  QUERY_STRING:	GET ˤ䤤碌ˤ
 *  REMOTE_HOST:	ץȤФƤۥȤΥۥ̾
 *  REMOTE_ADDR:	ץȤФƤۥȤ IP ɥ쥹
 *  REMOTE_USER:	ץȤФƤ桼Υ桼̾
 *  CONTENT_TYPE:	POST ˤäƥեबФ硢
 *			application/x-www-form-urlencoded
 *  CONTENT_LENGTH:	POST ɸϤɤ߹ɬפΤХȿ
 */
#define	DEFAULT_PATH	"/bin:/usr/bin:/usr/ucb:/usr/bsd:/usr/local/bin"
static void SetEnvironments(req)
	Request	*req;
{
  register char	*a, *c, *p;
  char		buf[PATH_LEN];

  envno = 0;
  if ((p = getenv("PATH")) != NULL) {			  /* ѥ	   */
    MakeNewEnvironment("PATH", p);
  }
  else {
    MakeNewEnvironment("PATH", DEFAULT_PATH);
  }

  if ((p = getenv("HOME")) != NULL) {			  /* HOME    */
    MakeNewEnvironment("HOME", p);
  }

  if ((p = getenv("TZ")) != NULL) {			  /* Ӥ  */
    MakeNewEnvironment("TZ", p);
  }

  c = req->url;
  if ((p = (char *)strstr(c, CGI_SUFFIX)) != NULL) {	  /* PATH_INFO  */
    p += 4;				/* .cgi νü˰ư		    */
    if ((*p == '?') && IsEqual(req->method, "GET")) {	  /* GET ᥽å?  */
      MakeNewEnvironment("QUERY_STRING", p + 1);	  /* CGI    */
    }
    *p = EOL;				/* ʸüĤ	    */
    p++;				/* PATH_INFO Ƭ˰ư	    */
  }
  MakeNewEnvironment("SCRIPT_NAME", c);			  /* CGI ޥ   */

  if (*p != NULL) {					  /* PATH_INFO  */
    (void)sprintf(buf, "/%s", p);
    MakeNewEnvironment("PATH_INFO", buf);		  /* PATH_INFO  */
    (void)sprintf(buf, "%s%s", serv.file.virtual, p);
    MakeNewEnvironment("PATH_TRANSLATED", buf);   /* PATH_TRANSLATED  */
  }

  MakeNewEnvironment("SERVER_SOFTWARE", SERVER);	  /* ̾	   */
  MakeNewEnvironment("SERVER_NAME", serv.name);		  /* ۥ̾	   */
  (void)sprintf(buf, "%d", serv.port);
  MakeNewEnvironment("SERVER_PORT", buf);		  /* ݡֹ	   */
  MakeNewEnvironment("REMOTE_HOST", host.fqdn);		  /* ֥ۥ̾  */
  MakeNewEnvironment("REMOTE_ADDR", host.ip_addr);	  /* ֥ۥIP  */
  MakeNewEnvironment("DOCUMENT_ROOT", serv.file.real);	  /* HTMLʸDIR   */
  MakeNewEnvironment("GATEWAY_INTERFACE", INTERFACE);	  /* CGI Version   */
  MakeNewEnvironment("SERVER_PROTOCOL", PROTOCOL);	  /* HTTP Protocol */
  MakeNewEnvironment("REQUEST_METHOD", req->method);	  /* HTTP Method   */
  MakeNewEnvironment("HTTP_USER_AGENT", req->user_agent); /* User AgentCGI */
  MakeNewEnvironment("HTTP_FORWARDED", req->forwarded);	  /* Proxy Gateway */
  MakeNewEnvironment("HTTP_REFERER", req->referer);	  /*  URL	   */
  if (IsEqual(req->method, "POST")) {	/* POST ᥽åɤλ	   */
    MakeNewEnvironment("CONTENT_TYPE", req->content_type);
    (void)sprintf(buf, "%d", req->content_length);
    MakeNewEnvironment("CONTENT_LENGTH", buf);
  }
  env[envno] = NULL;
}

/*
 * ؿ̾:	MakeNewEnvironment
 * ǽ:	Ķѿ
 * :	ʤ
 */
static void MakeNewEnvironment(name, value)
	char	*name, *value;
{
  char	buf[BUF_SIZE];

  (void)sprintf(buf, "%s=%s", name, value);
  if ((env[envno] = (char *)malloc(strlen(buf) + 1)) == NULL) {
    env[envno] = NULL;
  }
  (void)strcpy(env[envno], buf);
  envno++;
}

/*
 * ؿ̾:	FreeMakedEnvironment
 * ǽ:	Ķѿΰ
 * :	ʤ
 */
static void FreeMakedEnvironment(void)
{
  int	i;

  for (i=0; i<envno; i++) {
    (void)free(env[i]);
  }
}

/*
 * ؿ̾:	WaitProcess
 * ǽ:	ҥץνλߤԤ
 * :	ʤ
 * :	ҥץξ
 */
int WaitProcess(void)
{
  int	status;
  pid_t	pid;

  while ((pid = waitpid((pid_t)-1, &status, WNOHANG)) > 0) {
    ;	/* ⤷ʤԤäƤ	*/
  }

  return(status);
}

