/*
 * wath_config.c - wath ⥸塼
 *    Tue, Mar 5 1996 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include "common.h"
#include "config.h"

/*
 * ޥ
 */
#define	CHANGED		1			/* ꤬ѹ줿	*/
#define	CLEAR		0			/* ѿ򥯥ꥢ		*/
#define	WATH_PID	"wath.pid"		/* PID ¸ե̾	*/

#define	ERROR_LOG	"logs/error_log"	/* 顼		*/
#define	ACCESS_LOG	"logs/access_log"	/* 	*/
#define	USER_LOG	"logs/user_log"		/* 桼		*/
#define	HOST_LOG	"logs/host_log"		/* ۥȡ		*/
#define	AGENT_LOG	"logs/agent_log"	/* ȡ	*/
#define	REFER_LOG	"logs/refer_log"	/*  URL 	*/

/*
 * ¤Τ
 */
typedef struct {
  char	file[PATH_LEN];
  int	flag;
} ConfLogs;

/*
 * ؿ̾:	DefaultConfiguration
 * ǽ:	wath ΥǥեȤΥѥ᡼
 * :	ʤ
 */
void DefaultConfiguration(void)
{
  config_file = CONFIG_FILE;	/* Configuration ե̾	*/
  serv.port   = SERVICE_PORT;	/* ӥݡֹ		*/

  /* Żҥ᡼륢ɥ쥹	*/
  (void)strcpy(serv.admin, SERVER_ADMIN);

  /* ե¸ǥ쥯ȥ	*/
  (void)strcpy(serv.root, SERVER_ROOT);
  if (serv.root[strlen(serv.root)] == '/') {	/* ѥκǸ夬 / ǽλ */
    serv.root[strlen(serv.root)] = EOL;		/*  / 	   */
  }

  /* Сۥ̾		*/
  (void)strcpy(serv.name, SERVER_NAME);

  /* CGI Ѳۥǥ쥯ȥ	*/
  (void)strcpy(serv.cgi.virtual, VEXEC_DIR);

  /* CGI Ѽ¥ǥ쥯ȥ		*/
  (void)strcpy(serv.cgi.real, REXEC_DIR);

  /* HTML Ѳۥǥ쥯ȥ	*/
  (void)strcpy(serv.file.virtual, VFILE_DIR);

  /* HTML Ѽ¥ǥ쥯ȥ	*/	
  (void)strcpy(serv.file.real, RFILE_DIR);

  /* Welcome Page CGI ѥե̾	*/
  (void)strcpy(serv.welcome, WELCOME_PAGE_CGI);

  /* mime types ե	*/
  (void)sprintf(serv.mime, "%s/%s", serv.root, MIME_TYPES_CONFIG_FILE);

  /* ۥȤΥĥե(access.allow)	*/
  (void)sprintf(serv.access.allow, "%s/%s", serv.root, HOST_ACCESS_ALLOW_FILE);

  /* ۥȤΥݥե(access.deny)	*/
  (void)sprintf(serv.access.deny, "%s/%s", serv.root, HOST_ACCESS_DENY_FILE);

  /* 桼Υե(private.conf)	*/
  (void)sprintf(serv.private, "%s/%s", serv.root, USER_ACCESS_CONTROL_FILE);

  /* PID ¸ե	*/
  (void)sprintf(serv.wath_pid, "%s/%s", serv.root, WATH_PID);

  /* 顼ѥե̾	*/
  (void)sprintf(serv.log.error, "%s/%s", serv.root, ERROR_LOG);

  /* ѥե̾	*/
  (void)sprintf(serv.log.access, "%s/%s", serv.root, ACCESS_LOG);

#ifdef	MORE_LOG
  /* 桼ѥե̾	*/
  (void)sprintf(serv.log.user, "%s/%s", serv.root, USER_LOG);

  /* ۥѥե̾	*/
  (void)sprintf(serv.log.host, "%s/%s", serv.root, HOST_LOG);

  /* ѥե̾	*/
  (void)sprintf(serv.log.agent, "%s/%s", serv.root, AGENT_LOG);

  /* եѥե̾	*/
  (void)sprintf(serv.log.refer, "%s/%s", serv.root, REFER_LOG);
#endif	/* MORE_LOG	*/

  /* JIS ɤѴ	*/
  serv.jisout = NO_JISOUT;	/* ǥեȤϤΤޤޤδɤ	*/
}

/*
 * ؿ̾:	Configuration
 * ǽ:	СѳƼѥ᡼
 * :	ʤ
 */
#define	MAX_ARGS	3
#define	TOKEN		"\r\n\t "

void Configuration(void)
{
  register FILE	*fp;
  char		buf[BUF_SIZE], *args[MAX_ARGS];
  int		col, root;
  ConfLogs	mime, allow, deny, user;

#ifdef SYSTEM_V
  signal(SIGHUP, SIG_IGN);
#endif

  /* ѿν	*/
  root = CLEAR;
  mime.flag = allow.flag = user.flag = CLEAR;
  (void)strcpy(mime.file,  MIME_TYPES_CONFIG_FILE);
  (void)strcpy(allow.file, HOST_ACCESS_ALLOW_FILE);
  (void)strcpy(deny.file,  HOST_ACCESS_DENY_FILE);
  (void)strcpy(user.file,  USER_ACCESS_CONTROL_FILE);

  /* եΥץ	*/
  if ((fp = fopen(config_file,"r")) == NULL) {
    perror(config_file);
    exit(1);
  }

  /* ե˽äƳƼѥ᡼	*/
  while (fgets(buf, BUF_SIZE, fp) != NULL) {
    if (SkipLine(buf)) {			/* ȹԤϥå	*/
      continue;
    }
    if ((col = Split(buf, args, TOKEN, MAX_ARGS)) < MAX_ARGS - 1) {
      continue;
    }
    switch (col) {
      case 2:
        if (IsEqual(args[0], "Port")) {			/* ݡֹ	*/
	  serv.port = atoi(args[1]);
	}
	else if (IsEqual(args[0], "ServerAdmin")) {	/* ̾	*/
	  (void)strcpy(serv.admin, args[1]);
	}
	else if (IsEqual(args[0], "ServerRoot")) {	/* ¸	*/	
	  (void)strcpy(serv.root, args[1]);
	  if (serv.root[strlen(serv.root)] == '/') {
	    serv.root[strlen(serv.root)] = EOL;
	  }
	  root = CHANGED;
	}
	else if (IsEqual(args[0], "MimeTypes")) {	/* MIME Types	*/
	  (void)strcpy(mime.file, args[1]);
	  mime.flag = CHANGED;
	}
	else if (IsEqual(args[0], "HostAllow")) {	/* 	*/
	  (void)strcpy(allow.file, args[1]);
	  allow.flag = CHANGED;
	}
	else if (IsEqual(args[0], "HostDeny")) {	/* 	*/
	  (void)strcpy(deny.file, args[1]);
	  deny.flag = CHANGED;
	}
	else if (IsEqual(args[0], "UserAccess")) {	/* 桼	*/
	  (void)strcpy(user.file, args[1]);
	  user.flag = CHANGED;
	}
	else if (IsEqual(args[0], "ServerName")) {	/* С̾	*/
	  (void)strcpy(serv.name, args[1]);
	}
	else if (IsEqual(args[0], "WelcomePageCGI")) {	/* Welcome Page	*/
	  (void)strcpy(serv.welcome, args[1]);
	}
	else {
	  (void)fprintf(stderr, "Configuration Error: unexpected type (%s)\n",
			args[0]);
	  (void)fclose(fp);
	  exit(1);
	}
	break;

      case 3:
        if (IsEqual(args[0], "Exec")) {			/* CGI ξ	*/
          (void)strcpy(serv.cgi.virtual, args[1]);
	  (void)strcpy(serv.cgi.real, args[2]);
        }
        else if (IsEqual(args[0], "Doc")) {		/* HTML ξ	*/
          (void)strcpy(serv.file.virtual, args[1]);
  	  (void)strcpy(serv.file.real, args[2]);
        }
        else {
          (void)fprintf(stderr, "Configuration Error: unexpected type (%s)\n",
			args[0]);
	  (void)fclose(fp);
	  exit(1);
	}
	break;

      default:
        (void)fprintf(stderr, "Configuration Error: unexpected type (%s)\n",
		      args[0]);
	(void)fclose(fp);
	exit(1);
    }
  }
  (void)fclose(fp);

  /* ѥطѹ줿ν	*/

  /* MIME Type եΥѥѹ	*/
  if (root || mime.flag) {
    (void)sprintf(serv.mime, "%s/%s", serv.root, mime.file);
  }

  /* ĥۥȡեΥѥѹ */
  if (root || allow.flag) {
    (void)sprintf(serv.access.allow, "%s/%s", serv.root, allow.file);
  }

  /* ݥۥȡեΥѥѹ */
  if (root || deny.flag) {
    (void)sprintf(serv.access.deny, "%s/%s", serv.root, deny.file);
  }

  /* 桼եΥѥѹ */
  if (root || user.flag) {
    (void)sprintf(serv.private, "%s/%s", serv.root, user.file);
  }

 /* PID ¸ե / ƼեΥѥѹ	*/
  if (root) {
    (void)sprintf(serv.wath_pid,   "%s/%s", serv.root, WATH_PID);

    (void)sprintf(serv.log.error,  "%s/%s", serv.root, ERROR_LOG);
    (void)sprintf(serv.log.access, "%s/%s", serv.root, ACCESS_LOG);
#ifdef	MORE_LOG
    (void)sprintf(serv.log.user,   "%s/%s", serv.root, USER_LOG);
    (void)sprintf(serv.log.host,   "%s/%s", serv.root, HOST_LOG);
    (void)sprintf(serv.log.agent,  "%s/%s", serv.root, AGENT_LOG);
    (void)sprintf(serv.log.refer,  "%s/%s", serv.root, REFER_LOG);
#endif	/* MORE_LOG */
  }

#ifdef SYSTEM_V
  signal(SIGHUP, ReConfiguration);
#endif
}

/*
 * ؿ̾:	ReConfiguration
 * ǽ:	Ƽեɤľ
 * :	ʤ
 */
void ReConfiguration(void)
{
  /* եɤ߹	*/
  Configuration();

  /* MIME Type ǡ١ν	*/
  MakeMimeTypesDataBase();

  /* ǽʥۥȤΥơ֥	*/
  InitAccessHosts();

  /*  URL ơ֥ν	*/
  InitPrivateURLList();
}

