/*
 * wath_mime.c - wath  MIME Type ⥸塼
 *    Thu, Mar 7 1996 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef	SYSTEM_V
#include <signal.h>
#endif
#include "common.h"

/*
 * ޥ
 */
#define	MIME_TYPE_MAX	256
#define	FILE_LEN	80
#define	MTYPE_SIZE	40
#define	EXTENSION_SIZE	10
#define	TOKEN1		":\t\r\n"
#define	TOKEN2		" \r\n"
#define	DEFAULT_TYPE	"text/plain"

#define	BUCKET_SKIP	5		/* ƥϥåѥå״ֳ	*/
#define	EMPTY		"EMPTY"		/* ä	*/
#define	DELETED		"DELETED"	/* 줿	*/
#define	NOT_FOUND	-1		/* Ĥʤ	*/

/*
 * ¤Τ
 */
typedef struct {
  char	type[MTYPE_SIZE];
  char	extension[EXTENSION_SIZE];
} MIME_TYPE;

/*
 * ɽؿ
 */
static void	MTypeDBInit();
static int	hash();
static int	rehash();
static int	MTypeDBKeyEqual();
static int	MTypeDBFind();
static int	MTypeDBInsert();
static void	Reverse();

/*
 * ɽѿ
 */
static MIME_TYPE	mtype[MIME_TYPE_MAX];

/*
 * ؿ̾:	MakeMimeTypesDataBase
 * ǽ:	MIME Type ѥǡ١κ
 * :	ʤ
 */
void MakeMimeTypesDataBase(void)
{
  register FILE	*fp;
  MIME_TYPE	mt[MIME_TYPE_MAX];
  char		buf[BUF_SIZE], tmp[BUF_SIZE/4], *p;
  int		i, mnum;

#ifdef SYSTEM_V
  signal(SIGHUP, SIG_IGN);
#endif

  /* mime.types եΥץ	*/
  if ((fp = fopen(serv.mime, "r")) == NULL) {
    perror(serv.mime);
    exit(1);
  }

  /* MIME Type ѥǡ١ν	*/
  MTypeDBInit();
  
  /* MIME Type ѥǡɤ߹	*/
  mnum = 0;
  while (fgets(buf, BUF_SIZE, fp) != NULL) {
    if (SkipLine(buf)) {	/* ȹԤϥå	*/
      continue;
    }
    if ((p = (char *)strtok(buf, ":\t")) != NULL) {	/* mime types	*/
      (void)strcpy(mt[mnum].type, p);
      if ((p = (char *)strtok(NULL, TOKEN1)) != NULL) {	/* extension	*/
	(void)strcpy(tmp, p);
	(void)strcpy(mt[mnum].extension, tmp);
	if ((p = (char *)strtok(tmp, TOKEN2)) != NULL) {
	  (void)strcpy(mt[mnum].extension, p);
	  while ((p = (char *)strtok(NULL, TOKEN2)) != NULL) {
	    mnum++;
	    (void)strcpy(mt[mnum].type, mt[mnum-1].type);
	    (void)strcpy(mt[mnum].extension, p);
	  }
	}
      }
      else {
        mt[mnum].extension[0] = EOL;
      }
      mnum++;
    }
  }
  (void)fclose(fp);

  /* MIME Type ѥǡ١κ	*/
  for (i=0; i<mnum; i++) {
    if (mt[i].extension[0] == EOL) {
      continue;
    }
    (void)MTypeDBInsert(mt[i].extension, mt[i].type);
  }
#ifdef SYSTEM_V
  signal(SIGHUP, ReConfiguration);
#endif
}

/*
 * ؿ̾:	ContentType
 * ǽ:	HTML  Content-Type η
 * :	HTML  Content-Type ʸ
 */
char *ContentType(filepath)
	char	*filepath;
{
  char	extension[EXTENSION_SIZE];
  int	h, i, j;

  /* ĥҤȴФ	*/
  for (i=0, j=strlen(filepath)-1; 
       (i<j && filepath[j] != '.' && filepath[j] != '/' && i<EXTENSION_SIZE);
       i++, j--) {
    extension[i] = filepath[j];
  }
  extension[i] = EOL;
  Reverse(extension);

  /* MIME Type ǡ١ Content-Type ꤹ	*/
  if ((h = MTypeDBFind(extension)) != NOT_FOUND) {
    return(mtype[h].type);
  }

  return(DEFAULT_TYPE);
}

/*
 * ؿ̾:	MTypeDBInit
 * ǽ:	MIME Type ѥϥåɽؿ
 * :	ʤ
 */
static void MTypeDBInit(void)
{
  int	i;

  for (i=0; i<MIME_TYPE_MAX; i++) {
    (void)strcpy(mtype[i].extension , EMPTY);
  }
}

/*
 * ؿ̾:	hash
 * ǽ:	ϥåͤؿ
 * :	ϥå
 */
static int hash(key)
	char	*key;
{
  int	i = 0;

  while (*key) {
    i += *key++;
  }

  return(i % MIME_TYPE_MAX);
}

/*
 * ؿ̾:	rehash
 * ǽ:	ƥϥåδؿ
 * :	ϥå
 */
static int rehash(h)
	int	h;
{
  return((h + BUCKET_SKIP) % MIME_TYPE_MAX);
}

/*
 * ؿ̾:	MTypeDBKeyEqual
 * ǽ:	Ӥ򤹤ؿ
 * :	(SUCCESS:1) or ʤ(FAILURE:0)
 */
static int MTypeDBKeyEqual(h, key)
	int	h;
	char	*key;
{
  if (IsEqual(mtype[h].extension, key)) {
    return(SUCCESS);
  }
  else {
    return(FAILURE);
  }
}

/*
 * ؿ̾:	MTypeDBFind
 * ǽ:	ˤõԤؿ
 * :	бϥå
 */
static int MTypeDBFind(key)
	char	*key;
{
  int	h, count = 0;

  h = hash(key);
  while (count < MIME_TYPE_MAX) {
    count++;
    if (MTypeDBKeyEqual(h, key) == SUCCESS) {
      return(h);
    }
    h = rehash(h);
  }
  return(NOT_FOUND);
}

/*
 * ؿ̾:	MTypeDBInsert
 * ǽ:	MIME Type ѥϥåɽ˥ǡؿ
 * :	(SUCCESS:1) or (FAILURE:0)
 */
static int MTypeDBInsert(key, data)
	char	*key, *data;
{
  int	h, count = 0;

  h = hash(key);
  while (count < MIME_TYPE_MAX) {
    count++;
    if (IsEqual(mtype[h].extension, EMPTY) ||
	IsEqual(mtype[h].extension, DELETED)) {
      (void)strcpy(mtype[h].extension, key);
      (void)strcpy(mtype[h].type, data);
      return(SUCCESS);
    }
    h = rehash(h);
  }
  return(FAILURE);
}

/*
 * ؿ̾:	Reverse
 * ǽ:	Ϳ줿ʸսˤ
 * :	ʤ
 */
static void Reverse(s)
	char	*s;
{
  int	c, i, j;

  for (i=0, j=strlen(s)-1; i<j; i++, j--) {
    c	 = s[i];
    s[i] = s[j];
    s[j] = c;
  }
}

