/*
 * wath_network - wath ѥͥåȥ⥸塼
 *    Mon, Mar 4 1996 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <arpa/nameser.h>
#include <netdb.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include "status_code.h"
#include "common.h"

#define	HOST_MAX_ENTRY	10	/* 椹ۥȿ	*/
#define	HOST_LEN	40	/* ۥ̾Ĺ		*/

/*
 * ɽѿ
 */
static char	allowHostTable[HOST_MAX_ENTRY][HOST_LEN];
static int	allowHostNum;
static char	denyHostTable[HOST_MAX_ENTRY][HOST_LEN];
static int	denyHostNum;

/*
 * ؿ̾:	InitConnection
 * ǽ:	ͥåȥ³ν
 * :	ʤ
 */
void InitConnection(void)
{
  struct sockaddr_in	server;
  int			on;

  /* ͥåȥȥ	*/
#ifdef SYSTEM_V
  memset(&server, 0, sizeof(server));
#else
  bzero((char *)&server, sizeof(server));
#endif
  server.sin_family	 = AF_INET;
  server.sin_port	 = htons(serv.port);
  server.sin_addr.s_addr = INADDR_ANY;

  /* åȤκ	*/
  if ((soc = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");
    exit(1);
  }

  /* åȡץ	*/
  on = 1;	/* address already in use н	*/
  if (setsockopt(soc, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on)) < 0) {
    perror("setsockopt: SO_REUSEADDR");
    exit(1);
  }
  on = 1;	/* CGI ޥɤ֥饦鶯λ줿н	*/
  if (setsockopt(soc, SOL_SOCKET, SO_KEEPALIVE, (char *)&on, sizeof(on)) < 0) {
    perror("setsockopt: SO_KEEPALIVE");
    exit(1);
  }

  /* åȤη	*/
  if (bind(soc, (struct sockaddr *)&server, sizeof(server)) < 0) {
    perror("bind");
    exit(1);
  }

  /* å³Τ listen	*/
  if (listen(soc, 5) < 0) {
    perror("listen");
    exit(1);
  }
}

/*
 * ؿ̾:	AcceptConnection
 * ǽ:	TCP/IP ݡȤ˳Ƥ줿å³μդ
 * :	ʤ
 */
void AcceptConnection(void)
{
  int			addrlen;
  struct hostent	*hp;

  /* ³μ	*/
  addrlen = sizeof(struct sockaddr_in);
  if ((sd = accept(soc, (struct sockaddr *)&client, &addrlen)) < 0) {
    if (errno == EINTR) {
      (void)WaitProcess();
    }
    else {
      perror("accept");
      exit(1);
    }
  }

  /* ³Υۥ̾	*/
  hp = gethostbyaddr((char *)&client.sin_addr,
		     sizeof(client.sin_addr), AF_INET);
  if (hp != NULL) {
    strcpy(host.fqdn, hp->h_name);	/* FQDN 	*/
  }
  else {
    host.fqdn[0] = EOL;
  }
  strcpy(host.ip_addr, inet_ntoa(client.sin_addr));	/* IP ɥ쥹 */
}

/*
 * ؿ̾:	InitAccessHosts
 * ǽ:	ǽʥۥȤΥơ֥
 * :	ʤ
 */
void InitAccessHosts(void)
{
  register FILE	*fp;
  register char	*p;
  char		buf[HOST_LEN];

#ifdef SYSTEM_V
  signal(SIGHUP, SIG_IGN);
#endif

  allowHostNum = 0;			/* ĥۥȿ	*/
  denyHostNum  = 0;			/* ݥۥȿ	*/

  /* ĥեΥץ	*/
  if ((fp = fopen(serv.access.allow, "r")) != NULL) {

    /* ĥۥȤΥơ֥	*/
    while (fgets(buf, HOST_LEN, fp) != NULL) {
      if (SkipLine(buf)) {		/* ȹԤʤɤΥå	*/
	continue;
      }
      else {					/* ĥۥȤϿ	*/
	if ((p = strchr(buf, LF)) != NULL) {	/* βԽ	*/
	  *p = EOL;
	}
	(void)strcpy(allowHostTable[allowHostNum++], buf);
      }
    }
    (void)fclose(fp);				/* եĤ	*/
  }

  /* ݥեΥץ	*/
  if ((fp = fopen(serv.access.deny, "r")) != NULL) {

    /* ݥۥȤΥơ֥	*/
    while (fgets(buf, HOST_LEN, fp) != NULL) {
      if (SkipLine(buf)) {		/* ȹԤʤɤΥå	*/
	continue;
      }
      else {					/* ݥۥȤϿ	*/
	if ((p = strchr(buf, LF)) != NULL) {	/* βԽ	*/
	  *p = EOL;
	}
	(void)strcpy(denyHostTable[denyHostNum++], buf);
      }
    }
    (void)fclose(fp);				/* եĤ	*/
  }

#ifdef SYSTEM_V
  signal(SIGHUP, ReConfiguration);
#endif
}

/*
 * ؿ̾:	AccessCheck
 * ǽ:	ФΥĤΥå
 * :	(ACCESS_ALLOW) or Ե(ACCESS_DENY)
 */
int AccessCheck(void)
{
  register int	n;

  /* ݥۥȤå	*/
  for (n = 0; n < denyHostNum; n++) {
    if (IsMatching(host.fqdn,	 denyHostTable[n]) ||
	IsMatching(host.ip_addr, denyHostTable[n])) {
      ErrorTrap(SERVICE_UNAVAILABLE);	/* 顼˵Ͽ		*/
      (void)close(sd);			/* 饤ȤȤ³	*/
      return(ACCESS_DENY);		/* 			*/
    }
  }

  /* ĥۥȤå	*/
  for (n = 0; n < allowHostNum; n++) {
    if (IsMatching(host.fqdn,	 allowHostTable[n]) ||
	IsMatching(host.ip_addr, allowHostTable[n])) {
      return(ACCESS_ALLOW);		/* 			*/
    }
  }

  if (allowHostNum > 0) {
    ErrorTrap(SERVICE_UNAVAILABLE);	/* 顼˵Ͽ		*/
    (void)close(sd);			/* 饤ȤȤ³	*/
    return(ACCESS_DENY);		/* 			*/
  }

  return(ACCESS_ALLOW);			/* ƤΥۥȤΥ	*/
}

/*
 * ؿ̾:	SendMail
 * ǽ:	᡼
 * :	֥ȡ
 * :	ʤ
 */
void SendMail(subject, body)
	char	*subject, *body;
{
  register FILE	*fp;
  char		buf[BUF_SIZE];

  /* ۾ｪλˤ᡼ʸκ	*/
  (void)sprintf(buf, "To: %s\nSubject: %s\n%s\n\n%s\n", serv.admin, subject,
		Date(NULL), body);

  if ((fp = popen(SENDMAIL, "w")) != NULL) {	/* ᡼		*/
#ifdef	JP_MESG					/* ܸΥ᡼	*/
    fputs((char *)JapaneseStringConvertTo(buf, JIS), fp);
#else						/* ѸΥ᡼		*/
    fputs(buf, fp);
#endif	/* JP_MESG */
    (void)pclose(fp);
  }
  signal(SIGPIPE, SIG_IGN);
}

