/*
 * wathpasswd.c - եؤΥ桼Ͽ
 *    Sun, Jun 23 1996 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#ifdef	__FreeBSD__
#include <des.h>
#endif
#include "config.h"

/*
 * ޥ
 */
#define	USERNAME_SIZE	9		/* 桼̾Υ	     */
#define	PASSWORD_SIZE	14		/* ѥΥ	     */
#define	SALT_SIZE	3		/* ѥɤ̣դʸ󥵥  */
#define	PRIVATE_FILE	CONFDIR ## "/private.passwd" /* ե */

#define	BUF_SIZE	80		/* ѥХåե	*/
#define	SUCCESS		1		/* 	*/
#define	FAILURE		0		/* 	*/

/*
 * ¤Τ
 */
typedef struct {
  char	username[USERNAME_SIZE];
  char	password[PASSWORD_SIZE];
} Authorization;

/*
 * ɽؿ
 */
static int	GetAccessEntry();

/*
 * ؿ̾:	GetAccessEntry
 * ǽ:	桼Υȥꤹ
 * :	(SUCCESS:1) or (FAILURE:0)
 */
int GetAccessEntry(ac, username)
	Authorization	*ac;
	char		*username;
{
  register FILE	*fp;
  char		buf[BUF_SIZE], *p;

  /* եΥץ	*/
  if ((fp = fopen(PRIVATE_FILE, "r")) == NULL) {
    return(FAILURE);
  }

  /* եθ	*/
  while (fgets(buf, BUF_SIZE, fp) != NULL) {
    if ((p = (char *)strtok(buf, ":")) != NULL) {
      if (strcmp(username, p) == 0) {			/* 桼ȯ	*/
	(void)strcpy(ac->username, p);
	if ((p = (char *)strtok(NULL, "\n")) != NULL) {
	  (void)strcpy(ac->password, p);	
	}
	else {
	  (void)strcpy(ac->password, (char)NULL);
	}
	(void)fclose(fp);
	return(SUCCESS);
      }
    }
  }
  (void)fclose(fp);
  return(FAILURE);
        
}

/*
 * ؿ̾:	SubscribeUser
 * ǽ:	ǽ桼Ͽ
 * :	(1) or (0)
 */
int SubscribeUser(username, key)
	char	*username, *key;
{
  register FILE	*fp;
  char		password[PASSWORD_SIZE], salt[SALT_SIZE];
  time_t	t;

  static unsigned char 	salt_chars[64] = 
    "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

  /* ѥɤα̣Ūʸκ	*/
  t = time((time_t *)NULL);
#ifdef	HAVE_RANDOM
  (void)srandom((unsigned int)t);
  salt[0] = salt_chars[(unsigned int)((int)t * (int)random()) % 64];
  salt[1] = salt_chars[(unsigned int)((int)t * (int)random()) % 64];
#else
  (void)srand((unsigned int)t);
  salt[0] = salt_chars[(unsigned int)((int)t * (int)rand()) % 64];
  salt[1] = salt_chars[(unsigned int)((int)t * (int)rand()) % 64];
#endif
  salt[2] = '\0';

  /* ѥɤκ	*/
  (void)strcpy(password, (char *)crypt(key, salt));

  /* եΥץ	*/
  if ((fp = fopen(PRIVATE_FILE, "a")) == NULL) {
    return(FAILURE);
  }

  /* Ͽ	*/
  (void)fprintf(fp, "%s:%s\n", username, password);

  (void)fclose(fp);
  return(SUCCESS);
}

/*
 * ؿ̾:	CheckUser
 * ǽ:	桼ǽĴ٤
 * :	(1) or Ե(0)
 */
int CheckUser(username, key)
	char	*username, *key;
{
  Authorization	ac;
  char		password[PASSWORD_SIZE], salt[SALT_SIZE];

  /* 桼Υȥ	*/
  if (GetAccessEntry(&ac, username) == FAILURE) {
    return(FAILURE);
  }

  /* ѥɤα̣Ūʸʬ	*/
  (void)strncpy(salt, ac.password, 2);
  (void)strcpy(password, (char *)crypt(key, salt));

  /* ѥɤΥå	*/
  if (strcmp(password, ac.password) == 0) {
    return(SUCCESS);
  }
  else {
    return(FAILURE);
  }
}

/*
 * ᥤؿ
 *
 */
int main(argc, argv)
	int	argc;
	char	**argv;
{
  if (argc > 0) {			/* ä	*/
    if (argc == 4) {
      if (strcmp(argv[1], "add") == 0) {
	SubscribeUser(argv[2], argv[3]);
	return(SUCCESS);
      }
      else if (strcmp(argv[1], "check") == 0) {
	if (CheckUser(argv[2], argv[3]) == SUCCESS) {
	  (void)fprintf(stdout, "%s was auhorized\n", argv[2]);
	  return(SUCCESS);
	}
	else {
	  (void)fprintf(stdout, "%s was not auhorized\n", argv[2]);
	  return(FAILURE);
	}
      }
      else {
	(void)fprintf(stderr,
		      "Usage: wathpasswd add|check username password\n");
	return(FAILURE);
      }
    }
    else {
      (void)fprintf(stderr, "Usage: wathpasswd add|check username password\n");
      return(FAILURE);
    }
  }
  return(1);
}

